unit MyTsx;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
	TsxApi, TsxHelper, TsxMain, Buttons, ComCtrls;

type
	TMyTsxForm = class(TTsxForm)
    NamesCombo: TComboBox;
    yMinusBtn: TSpeedButton;
    yPlusBtn: TSpeedButton;
    xPlusBtn: TSpeedButton;
    xMinusBtn: TSpeedButton;
    zPlusBtn: TSpeedButton;
    zMinusBtn: TSpeedButton;
		Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    AmountSpin: TUpDown;
    Edit1: TEdit;
    Label4: TLabel;
    RefreshListButton: TButton;
		procedure FormShow(Sender: TObject);
    procedure NamesComboChange(Sender: TObject);
		procedure xMinusBtnClick(Sender: TObject);
    procedure xPlusBtnClick(Sender: TObject);
    procedure yMinusBtnClick(Sender: TObject);
    procedure yPlusBtnClick(Sender: TObject);
    procedure zMinusBtnClick(Sender: TObject);
		procedure zPlusBtnClick(Sender: TObject);
    procedure RefreshListButtonClick(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
		procedure MoveObject(inX, inY, inZ: Single);
	end;

var
	MyTsxForm: TMyTsxForm;

implementation

{$R *.DFM}

procedure TraverseNodes(inNode: PTsxGNode);
var
	str: array[0..255] of Char;
	child: PTsxGNode;
begin
	if not Assigned(inNode) then exit;
	repeat
		begin
			tsxGNodeGetName(inNode, str, 256);
			with MyTsxForm.NamesCombo do
			begin
				Items.Add(StrPas(str));
				Items.Objects[Items.Count -1 ] := inNode;
			end;
			child := tsxGNodeGetFirstChild(inNode);
			TraverseNodes(child);
			inNode := tsxGNodeGetNext(inNode);
		end
	until not Assigned(inNode);
end;

procedure TMyTsxForm.RefreshListButtonClick(Sender: TObject);
begin
	NamesCombo.Clear;
	TraverseNodes(tsxSceneGetFirstNode);
end;

procedure TMyTsxForm.FormShow(Sender: TObject);
begin
	RefreshListButtonClick(Self);
end;

procedure TMyTsxForm.NamesComboChange(Sender: TObject);
begin
	with NamesCombo do
		if not tsxIsSelected(Items.Objects[ItemIndex]) then
			tsxSelectSobj(Items.Objects[ItemIndex], e_tsxSELECT, bDraw);
end;

procedure TMyTsxForm.MoveObject(inX, inY, inZ: Single);
var
	scale: Single;
begin
	scale := AmountSpin.Position / 10;
	with NamesCombo do
	begin
		if ItemIndex = -1 then exit;
		tsxGNodeTranslate(Items.Objects[ItemIndex], TsxVector3f(inX * scale, inY * scale, inZ * scale), e_tsxWorldFrame);
		tsxGNodeDraw(Items.Objects[ItemIndex]);
	end;
end;

procedure TMyTsxForm.xMinusBtnClick(Sender: TObject);
begin
	MoveObject(-1, 0, 0);
end;

procedure TMyTsxForm.xPlusBtnClick(Sender: TObject);
begin
	MoveObject(1, 0, 0);
end;

procedure TMyTsxForm.yMinusBtnClick(Sender: TObject);
begin
	MoveObject(0, -1, 0);
end;

procedure TMyTsxForm.yPlusBtnClick(Sender: TObject);
begin
	MoveObject(0, 1, 0);
end;

procedure TMyTsxForm.zMinusBtnClick(Sender: TObject);
begin
	MoveObject(0, 0, -1);
end;

procedure TMyTsxForm.zPlusBtnClick(Sender: TObject);
begin
	MoveObject(0, 0, 1);
end;

end.
